class MyMachine : public Machine {

    public:

    MyMachine(Epp *, ScreenOutput *, AudioOutput *, Keyboard *, Joystick *);

    uint8 readMem(const Component *, const uint16);
    void writeMem(const Component *, const uint16, const uint8);
    void out(const Component *, const uint16, const uint8);
    uint8 in(const Component *, const uint16);

    void emulate(void);
    void reset(void);

    protected:

    void createComponents(void);
    void destroyComponents(void);
    void readROMs(void);

    uint8 memory[0x10000];
    uint8 charROM[0x1000];

    Joystick *joystick;
    Keyboard *keyboard;

    _CPUCLASS_ *cpu;
    MyMachineVideo *vid;

};
