class Machine {

    public:
    
    Machine(Epp *, ScreenOutput *, AudioOutput *);

    virtual uint8 readMem(const Component *, const uint16) = 0;
    virtual void writeMem(const Component *, const uint16, const uint8) = 0;
    virtual void out(const Component *, const uint16, const uint8) = 0;
    virtual uint8 in(const Component *, const uint16) = 0;
    virtual void emulate(void) = 0;
    virtual void reset(void) = 0;

    static void readROM(const char *, uint8 *, const uint32);

    protected:

    virtual void readROMs(void) = 0;
    virtual void createComponents(void) = 0;
    virtual void destroyComponents(void) = 0;

    Epp *epp;
    ScreenOutput *display;
    AudioOutput *audio;

};
