#include "../../global.h"

LunarRescueVideo::LunarRescueVideo(Machine *hw, ScreenOutput *disp, uint8 *cr) : InvadersVideoHardware(hw, disp, cr) {

    // Nothing
}

void LunarRescueVideo::writeVideoRAM(uint16 addr, uint8 data) {

    int i,x,y;

    x = addr / 32;
    y = 256-16 - 8 * (addr % 32);

    if (y<0 || y>239) return;

    for (i = 0;i < 8;i++) {

        int col=1;

        if(y>=8-8 && y<16-8) {

            if(x<88-16) col=cyan;
            else if(x<176-16) col=red;
            else col=yellow;
        }
        else if(y<24-8) {

            if(x<88-16) col=cyan;
            else if(x<176-16) col=green;
            else col=yellow;
        }
        else if(y<32-8) {

            if(x<88-16) col=white;
            else if(x<176-16) col=green;
            else col=yellow;
        }
        else if(y<40-8) col=red;
        else if(y<64-8) col=purple;
        else if(y<96-8) col=green;
        else if(y<128-8) col=cyan;
        else if(y<160-8) col=purple;
        else if(y<192-8) col=yellow;
        else if(y<216-8) col=red;
        else if(y<232-8) col=cyan;
        else if(y<240-8) col=red;
        else {

            if(x<152-16) col=cyan;
            else if(x<200-16) col=purple;
            else col=cyan;
        }

        if (data & 0x80) {

            display->setScreenPixel(x, y, col);
        }
        else {

            display->setScreenPixel(x, y, col+6);
        }
        y++;
        data <<= 1;
    }
}

void LunarRescueVideo::setupDisplay(void) {

    display->setMode(224, 240, 60);

    display->setPalette(0, 0x000000);

    display->setPalette(white, 0xdddddd);
    display->setPalette(green, 0x33dd33);
    display->setPalette(red, 0xdd3333);
    display->setPalette(yellow, 0xdddd33);
    display->setPalette(cyan, 0x33dddd);
    display->setPalette(purple, 0xdd33dd);

    display->setPalette(white+6, 0x101010);
    display->setPalette(green+6, 0x002500);
    display->setPalette(red+6, 0x250000);
    display->setPalette(yellow+6, 0x252500);
    display->setPalette(cyan+6, 0x002525);
    display->setPalette(purple+6, 0x250025);

    for (int i=0; i<0x1bff; i++) {

        writeVideoRAM(i, 0);
    }
}
