class ScreenOutput {

	public:

	ScreenOutput();
	virtual ~ScreenOutput();

    virtual void setMode(const uint16, const uint16, const uint16);

	inline void setScreenPixel(const int16 x, const int16 y, const uint8 colour) {

    	// Memory
	    bitmap->line[y][x]=colour;

		// Linear
		// _farpokeb(screen->seg, (unsigned long)screen->line[y]+(x+xmod), colour);

    	// Banked

	    // unsigned long addr=bmp_write_line(screen, 2*y);
	    // _farpokeb(screen->seg, addr+(2*x), colour);
		// _farpokeb(screen->seg, addr+(2*x)+1, colour);

		// ModeX
		// outportw(0x3c4, (0x100<<(x&3))|2);
		// _farpokeb(screen->seg, (unsigned long)screen->line[y]+((x+xmod)>>2), colour);

    	//_put_pixel(screen, x+xmod, y, colour);
	}

    virtual void update(void);

    void setPalette(const uint8, const uint32);

    void setPixel(void *, const int16, const int16, const uint8);
    void drawLine(void *, const int16, const int16, const int16, const int16, const uint8);
    void drawChar(void *, const int16, const int16, const char, const uint8);
    void drawText(void *, const int16, const int16, char *, const uint8);
    void clearBitmap(void *, const uint8);

    uint16 getFPS(void) const;

    inline void *getScreen(void) const {

    	return bitmap;
    }

    void *createBitmap(const uint16, const uint16);
    void *loadBitmap(char *);
    void freeBitmap(void *);
    void createSpriteBank(uint8 **, void **, const uint16, const uint16, const uint16);
    void freeSpriteBank(void **, uint16);
    void copyBitmap(void *, void *, const int16, const int16, const uint8);
    void copyWrappedBitmap(void *, void *, const int16, const int16, const int16, const int16, const uint8);
	void drawSprite(void *, void *, const int16, const int16, const uint8, const uint8 *, const bool, const bool);
    void toggleFPS(void);

    enum tr { solid, transparent };

    protected:

    void drawFPS(void);

    uint16 width, height, xmod, ymod;
    uint16 fps;
    uclock_t ticks;
    uint16 framerate;
    BITMAP *bitmap;
    bool fpsflag;
};
